use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Document::XHTML::Config;

use Clarity -self;

field xhtml_stylesheets => [];

sub set_xhtmlstylesheets {
	push @{$self->xhtml_stylesheets}, split(' ', shift);
}

package Xyzzy::Document::XHTML;

use Xyzzy::Document -self;

sub serialize {
	my $res = new Xyzzy::Response;

	if($self->req->msie) {
		$res->mimetype('text/html', charset => 'UTF-8');
		$res->content($self->toStringHTML);
	} else {
		$res->mimetype('application/xhtml+xml');
		$res->content($self->toString);
	}

	return $res;
}

sub build {
	$self->hook_next;
	foreach my $sheet (@{$self->cfg->xhtml_stylesheets}) {
		$self->transform($sheet);
	}
}
